<template>
    <v-container grid-list-xs>
        <v-btn color="success"
            @click.stop="modal = true"
        >Add Operation</v-btn>

        <v-dialog
            v-model="modal"
            scrollable 
            max-width="500px"
            transition="dialog-transition"
        >
            <v-card>
                <v-card-title primary-title>
                    Add an Operation
                </v-card-title>

                <v-card-text>
                    <v-form @submit.prevent="add()">
                        <v-text-field
                            name="description"
                            label="Description"
                            v-model="operation.description"
                        ></v-text-field>

                        <v-text-field
                            name="amount"
                            label="Amount"
                            v-model="operation.amount"
                            type="number"
                            suffix="€"
                        ></v-text-field>

                        <v-select
                            :items="categories"
                            v-model="operation.category"
                            label="Category"
                            item-text="label"
                            item-value="id"
                        ></v-select>



                        <v-date-picker v-model="operation.date" :landscape="true" :reactive="true"></v-date-picker>
                        <v-btn color="success"
                        type="submit"
                        >Add</v-btn>
                    </v-form>
                </v-card-text>

                <v-card-actions>
                     <v-spacer></v-spacer>
                    <v-btn color="info" flat="flat" @click="modal = false">Close</v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-container>
</template>

<script>
import { mapState } from 'vuex';
export default {
    data() {
        return {
            modal: false,
            operation: {
                description: '',
                amount: 0,
                category: null,
                date: ''
            }
        }
    },
    computed: {
        ...mapState(['categories'])
    },
    mounted() {
        this.$store.dispatch('fetchCategories');
    },
    methods: {
        add() {
            this.$store.dispatch('addOperation', this.operation)
            .then(() => this.modal = false);
        }
    }
}
</script>

<style>

</style>
